#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
long long m[20005];
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long i,j,n,s,k;

    cin>>s>>n;
    m[0]=1;
    for(i=0;i<n;i++)
    {
        cin>>k;
        for(j=0;j<=20000;j++)
        {
            if(m[j])
            {
                if(m[j+k]==0)m[j+k]=m[j]+1;
                else m[j+k]=min(m[j+k],m[j]+1);
            }
        }
    }
    cout<<m[s]-1<<endl;
}
